import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsTeacherclass {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  ClassId!: IType<number, bigint>;
  SchoolId!: IType<number, bigint>;
  GradeId!: IType<number, bigint>;
  SubjectId!: IType<number, bigint>;
  TeacherId!: IType<number, bigint>;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsTeacherclassSchema = defineEntity({
  class: ScsTeacherclass,
  comment: '教师班级关系',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    ClassId: p.bigint().name('ClassId').columnType('bigint').comment('班级id'),
    SchoolId: p.bigint().name('SchoolId').columnType('bigint').comment('学校id'),
    GradeId: p.bigint().name('GradeId').columnType('bigint').comment('届id'),
    SubjectId: p.bigint().name('SubjectId').columnType('bigint').comment('科目id'),
    TeacherId: p.bigint().name('TeacherId').columnType('bigint').comment('教师id'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
